Subject: core dump when freeing pixmap

From: Mikhael Goikhman <[email-masked]>
Date: Mon, 24 Feb 2003 15:01:13 +0000

I got similar core dumps in the past, but now I can reproduce this.

I have a loop of fvwm in my xinitrc. So it starts infinitelly when
crashing (until I replace the fvwm executable).

The configuration is big (200 Kb of `fvwm-themes-config -e`) and I didn't
yet reduce it. But I may debug and patch something in order to solve this
problem. It is only I don't fully understand the logic in the code.

Trace:

GNU gdb Red Hat Linux (5.1.90CVS-5)
Core was generated by `fvwm -f themes-rc'.
#0  PDestroyFvwmPicture (dpy=0x80e4238, p=0x1f1) at Picture.c:149
149             if(--(p->count)>0)
(gdb) where
#0  PDestroyFvwmPicture (dpy=0x80e4238, p=0x1f1) at Picture.c:149
#1  0x0807645b in border_free_bar_pixmaps (dcd=0xbfffe780) at borders.c:1905
#2  0x0807a47d in border_draw_titlebar (cd=0xbfffe6d0, fw=0x81b7af0, 
    pressed_parts=PART_NONE, pressed_button=-1, 
    force_draw_parts=PART_TITLEBAR, clear_parts=CLEAR_ALL, old_g=0x0, 
    new_g=0x81b7cb4, do_hilight=0) at borders.c:4332
#3  0x0807ad90 in border_draw_decorations (fw=0x81b7af0, draw_parts=PART_ALL, 
    has_focus=0, do_force=1, clear_parts=CLEAR_ALL, old_g=0x0, new_g=0x81b7cb4)
    at borders.c:4711
#4  0x0807ae57 in border_redraw_decorations (fw=0x81d5bf0) at borders.c:4758
#5  0x080a22d5 in EWMH_SetIconFromWMIcon (fwin=0x81b7af0, list=0x81df040, 
    size=17424, is_mini_icon=1) at ewmh_icons.c:788
#6  0x080a1151 in ewmh_WMIcon (fwin=0x81b7af0, ev=0x0, style=0x0, any=0)
    at ewmh_icons.c:99
#7  0x0808ce88 in EWMH_WindowInit (fwin=0x81b7af0) at ewmh.c:1242
#8  0x0806c8ef in AddWindow (exc=0x81141c0, ReuseWin=0x0, win_opts=0xbfffed50)
    at add_window.c:2456
#9  0x08061dca in HandleMapRequestKeepRaised (ea=0xbfffecbc, KeepRaised=0, 
    ReuseWin=0x0, win_opts=0xbfffed50) at events.c:2348
#10 0x0806dc6e in CaptureAllWindows (exc=0x8114140, is_recapture=0)
    at add_window.c:3367
#11 0x08081285 in StartupStuff () at fvwm.c:1487
#12 0x08062fc3 in My_XNextEvent (dpy=0x80e4238, event=0xbfffef10)
    at events.c:3369
#13 0x08062f0f in HandleEvents () at events.c:3289
#14 0x08082072 in main (argc=3, argv=0xbffff444) at fvwm.c:2427
#15 0x40251977 in __libc_start_main () from /lib/libc.so.6
(gdb) 

Regards,
Mikhael.
--
Visit the official FVWM web page at <URL:http://www.fvwm.org/>.
To unsubscribe from the list, send "unsubscribe fvwm-workers" in the
body of a message to [email-masked].
To report problems, send mail to [email-masked]

---

From: Dominik Vogt <[email-masked]>
Date: Mon, 24 Feb 2003 17:03:11 +0100

> problem. It is only I don't fully understand the logic in the code.

I can take a look when you have stripped down the config file.

> #15 0x40251977 in __libc_start_main () from /lib/libc.so.6

Bye

Dominik ^_^  ^_^

---

From: Olivier Chapuis <[email-masked]>
Date: Wed, 26 Feb 2003 11:03:42 +0100

> I got similar core dumps in the past, but now I can reproduce this.

Can you reproduce it with my last commit?

> problem. It is only I don't fully understand the logic in the code.

The logic is a bit tricky. When you use UseTitleStyle style with colorset
or MultiPixmap a "unique" Pixmap or FvwmPicture is created for drawing
in  the titlebar and in the buttons with the UseTitleStyle style. So,
there is a kind of tmp cache when the decoration is drawn.

Olivier

---

From: Mikhael Goikhman <[email-masked]>
Date: Thu, 27 Feb 2003 04:23:58 +0000

> Can you reproduce it with my last commit?

It is fixed.

Regards,
Mikhael.